<template>
    <div>
        <button class="bg-blue-700 rounded py-2 px-4" @click="open = true">{{filename}}</button>
        <dialog-modal :show="open" @close="open = false">
            <template #title>
                <div class="text-white">
                    <slot>Show Picker</slot>
                </div>
            </template>
            <!-- TODO: Select user first -->
            <table class="block bg-gray-100 shadow table-auto rounded-b-lg">
                <thead>
                    <tr class="bg-gray-400 w-full">
                        <th v-for="(column,columnKey) in columns" :key="columnKey" class="px-4 py-2 border hover:bg-gray-500 transition-colors duration-300 ease-in-out" :class="column.class"  @click="column.nosort||sortBy(columnKey)">
                            {{column.title}}
                            <feather class="h-3" type='chevron-down' v-if="currentSort==columnKey && currentSortDir == 1" />
                            <feather class="h-3"  type='chevron-up' v-if="currentSort==columnKey && currentSortDir == -1" />
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <tr 
                        v-for="(show, index) in sortedFiles"
                        class="transition-colors duration-300 ease-in-out"
                        :class="{'bg-yellow-200':selectedId==index,'hover:bg-yellow-100':selectedId!=index,'bg-gray-200':index%2==1}" 
                        :key="index" 
                        @click.stop="select(show,index)"
                        @dblclick="pick">
                        <td class="px-4 py-2 border">{{show.name}}</td>
                        <td class="px-4 py-2 border">{{show.modified.format('lll')}}</td>
                    </tr>
                </tbody>
                <tfoot>
                    <tr>
                        <td :colspan="Object.keys(columns).length" class="text-center py-2">
                            <feather type="chevrons-left" class="cursor-pointer h-4 pt-1" @click="currentPage = 1" />
                            <feather type="chevron-left" class="cursor-pointer h-4 pt-1" @click="prevPage()" />
                            <a class="cursor-pointer" v-for="pagenum in pageNums" :key="pagenum" :class="{'font-bold':pagenum == currentPage}" @click="currentPage = pagenum">{{pagenum}}</a>
                            <feather type="chevron-right" class="cursor-pointer h-4 pt-1" @click="nextPage()" />
                            <feather type="chevrons-right" class="cursor-pointer h-4 pt-1 mr-4" @click="currentPage = Math.ceil(this.shows.length / this.pageSize)" />
                            <select v-model="pageSize">
                                <option value="10">10</option>
                                <option value="20">20</option>
                                <option value="25">25</option>
                                <option value="50">50</option>
                            </select>
                        </td>
                    </tr>
                </tfoot>
            </table>
            <template #footer><button class="bg-green-500 rounded" @click="pick">Select</button></template>
        </dialog-modal>
    </div>
</template>

<script>
import dayjs from 'dayjs'
import axios from 'axios'
import LocalizedFormat from 'dayjs/plugin/localizedFormat'
dayjs.extend(LocalizedFormat)

export default {
    props: {
        name: {
            type: String,
            default: "None"
        }
    },
    data(){
        return {
            open: false,
            selectedId: -1,
            currentSort: 'none',
            currentSortDir: '',
            sorting: false,
            pageSize: 10,
            currentPage: 1,
            shows: [],
            loading: false,
            userId: null,
            path: '',
            columns: {
                name: {
                    title: 'Show Name',
                    class: "w-7/12",
                },
                modified: {
                    title: "Last Modified",
                    class: "w-3/12"
                }
            },
        }
    },
    computed: {
        breadcrumb(){
            const breadcrumb = this.path.split('/');
            if(breadcrumb.length > 0) this.userId = breadcrumb.shift();
            else this.userId = null;
            return breadcrumb;
        },
        sortedFiles() {
            this.sorting = true;
            const ret = this.shows.sort((a,b)=> {
                if(this.currentSort === 'none') return 0;
                if(this.currentSort == 'modified') {
                    if(a[this.currentSort].isBefore(b[this.currentSort])) return -1 * this.currentSortDir;
                    if(a[this.currentSort].isAfter(b[this.currentSort])) return 1 * this.currentSortDir;
                } else if(typeof a[this.currentSort] === 'string') {
                    if(a[this.currentSort].toLowerCase() < b[this.currentSort].toLowerCase()) return -1 * this.currentSortDir;
                    if(a[this.currentSort].toLowerCase() > b[this.currentSort].toLowerCase()) return 1 * this.currentSortDir;
                } else {
                    if(a[this.currentSort] < b[this.currentSort]) return -1 * this.currentSortDir;
                    if(a[this.currentSort] > b[this.currentSort]) return 1 * this.currentSortDir;
                }
                return 0;
            }).filter((row, index) => {
                let start = (this.currentPage-1)*this.pageSize;
                let end = this.currentPage*this.pageSize;
                if(index >= start && index < end) return true;
            });
            this.sorting = false;
            return ret;
        },
        pageNums(){
            // Warn: This is not easily scalable
            const pages = Math.ceil(this.shows.length / this.pageSize);
            if(pages == 1) return [1];
            if(pages == 2) return [1,2];
            if(pages == 3) return [1,2,3];
            if(this.currentPage == 1) { // BEGIN
                return [this.currentPage, this.currentPage + 1, this.currentPage + 2];
            } else if(this.currentPage == pages) { // END
                return [this.currentPage - 2, this.currentPage - 1, this.currentPage];
            } else {
                return [this.currentPage - 1, this.currentPage, this.currentPage + 1]
            }
        },
    },
    mounted(){
        this.getPath();
    },
    watch: {
        path(){
            this.getPath();
        },
    },
    methods: {
        getPath(userId){
            this.loading = true;
            let url = '/user/'+userId+'/showlist';
            if(this.filter){
                if(typeof this.filter == 'object') url = url + "&filter=" + this.filter.join(",");
                else url = url + "&filter=" + this.filter;
            }
            axios.get(url).then(response=>{
                if(response.data.files){
                    // Directory
                    response.data.files.forEach((show)=>{
                        show.created_at = dayjs.unix(show.created_at);
                        show.modified = dayjs.unix(show.updated_at);
                    });
                    this.files = response.data.files;
                }
            }).finally(()=>{
                this.loading = false;
            });
        },
        sortBy(column){
            if(column != this.currentSort){
                this.currentSort = column;
                this.currentSortDir = 1;
            } else {
                if(this.currentSortDir > 0) {
                    this.currentSortDir = -1;
                } else {
                    this.currentSortDir = 1;
                }
            }
        },
        nextPage() {
            if((this.currentPage*this.pageSize) < this.files.length) {
                this.currentPage++;
            }
        },
        prevPage() {
            if(this.currentPage > 1) {
                this.currentPage--;
            }
        },
        select(show){
            this.selectedId = show.id;
        },
        pick(){
            if(this.selectedId < 0) return;
            this.$emit('change',this.shows[this.selectedId]);
            this.open = false;
        }
    },
}
</script>